



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用 kubeadm 搭建 kubernetes1.10 集群</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用 kubeadm 搭建 kubernetes1.10 集群</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-14 13:15:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>PS:所有节点安装之前记得先把镜像准备好，否者将无法启动，也不报错。</p>
<p>$ cat /etc/hosts<br />192.168.11.1 master<br />192.168.11.2 node</p>
<p>禁用防火墙：</p>
<pre class="prettyprint linenums"><code>$ systemctl stop firewalld<br />$ systemctl disable firewalld<br /></code></pre>
<p>禁用SELINUX：</p>
<pre class="prettyprint linenums"><code>$ setenforce 0<br />$ cat /etc/selinux/config<br />SELINUX=disabled<br /></code></pre>
<p>创建<code>/etc/sysctl.d/k8s.conf</code>文件，添加如下内容：</p>
<pre class="prettyprint linenums"><code>net.bridge.bridge-nf-call-ip6tables = 1<br />net.bridge.bridge-nf-call-iptables = 1<br />net.ipv4.ip_forward = 1<br /></code></pre>
<p>执行如下命令使修改生效：</p>
<pre class="prettyprint linenums"><code>$ modprobe br_netfilter<br />$ sysctl -p /etc/sysctl.d/k8s.conf<br /></code></pre>
<h2>镜像</h2>
<p>如果你的节点上面有科学上网的工具，可以忽略这一步，我们需要提前将所需的<code>gcr.io</code>上面的镜像下载到节点上面，当然前提条件是你已经成功安装了<code>docker</code>。</p>
<p><code>master</code>节点，执行下面的命令：</p>
<p>docker pull registry-vpc.cn-shenzhen.aliyuncs.com/cp_m/kube-apiserver-amd64:v1.10.0<br />docker pull registry-vpc.cn-shenzhen.aliyuncs.com/cp_m/kube-scheduler-amd64:v1.10.0<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/kube-controller-manager-amd64:v1.10.0<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/kube-proxy-amd64:v1.10.0<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/k8s-dns-kube-dns-amd64:1.14.8<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/k8s-dns-dnsmasq-nanny-amd64:1.14.8<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/k8s-dns-sidecar-amd64:1.14.8<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/etcd-amd64:3.1.12<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/flannel:v0.10.0-amd64<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/pause-amd64:3.1</p>
<p>docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/kube-apiserver-amd64:v1.10.0 k8s.gcr.io/kube-apiserver-amd64:v1.10.0<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/kube-scheduler-amd64:v1.10.0 k8s.gcr.io/kube-scheduler-amd64:v1.10.0<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/kube-controller-manager-amd64:v1.10.0 k8s.gcr.io/kube-controller-manager-amd64:v1.10.0<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/kube-proxy-amd64:v1.10.0 k8s.gcr.io/kube-proxy-amd64:v1.10.0<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/k8s-dns-kube-dns-amd64:1.14.8 k8s.gcr.io/k8s-dns-kube-dns-amd64:1.14.8<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/k8s-dns-dnsmasq-nanny-amd64:1.14.8 k8s.gcr.io/k8s-dns-dnsmasq-nanny-amd64:1.14.8<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/k8s-dns-sidecar-amd64:1.14.8 k8s.gcr.io/k8s-dns-sidecar-amd64:1.14.8<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/etcd-amd64:3.1.12 k8s.gcr.io/etcd-amd64:3.1.12<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/flannel:v0.10.0-amd64 quay.io/coreos/flannel:v0.10.0-amd64<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/pause-amd64:3.1 k8s.gcr.io/pause-amd64:3.1</p>
<pre class="prettyprint linenums"><code>&nbsp;</code></pre>
<p>可以将上面的命令保存为一个<code>shell</code>脚本，然后直接执行即可。这些镜像是在<code>master</code>节点上需要使用到的镜像，一定要提前下载下来。</p>
<p>其他<code>Node</code>，执行下面的命令：</p>
<p>docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/kube-proxy-amd64:v1.10.0<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/flannel:v0.10.0-amd64<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/pause-amd64:3.1<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/kubernetes-dashboard-amd64:v1.8.3<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/heapster-influxdb-amd64:v1.3.3<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/heapster-grafana-amd64:v4.4.3<br />docker pull registry.cn-shenzhen.aliyuncs.com/cp_m/heapster-amd64:v1.4.2</p>
<p>docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/flannel:v0.10.0-amd64 quay.io/coreos/flannel:v0.10.0-amd64<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/pause-amd64:3.1 k8s.gcr.io/pause-amd64:3.1<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/kube-proxy-amd64:v1.10.0 k8s.gcr.io/kube-proxy-amd64:v1.10.0</p>
<p>docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/kubernetes-dashboard-amd64:v1.8.3 k8s.gcr.io/kubernetes-dashboard-amd64:v1.8.3<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/heapster-influxdb-amd64:v1.3.3 k8s.gcr.io/heapster-influxdb-amd64:v1.3.3<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/heapster-grafana-amd64:v4.4.3 k8s.gcr.io/heapster-grafana-amd64:v4.4.3<br />docker tag registry.cn-shenzhen.aliyuncs.com/cp_m/heapster-amd64:v1.4.2 k8s.gcr.io/heapster-amd64:v1.4.2</p>
<pre class="prettyprint linenums"><code>&nbsp;</code></pre>
<p>上面的这些镜像是在<code>Node</code>节点中需要用到的镜像，在<code>join</code>节点之前也需要先下载到节点上面。</p>
<h2>安装 kubeadm、kubelet、kubectl</h2>
<p>在确保<code>docker</code>安装完成后，上面的相关环境配置也完成了，对应所需要的镜像(如果可以科学上网可以跳过这一步)也下载完成了，现在我们就可以来安装<code>kubeadm</code>了，我们这里是通过指定<code>yum</code>源的方式来进行安装的：</p>
<pre class="prettyprint linenums"><code>cat &lt;&lt;EOF &gt; /etc/yum.repos.d/kubernetes.repo<br />[kubernetes]<br />name=Kubernetes<br />baseurl=https://packages.cloud.google.com/yum/repos/kubernetes-el7-x86_64<br />enabled=1<br />gpgcheck=1<br />repo_gpgcheck=1<br />gpgkey=https://packages.cloud.google.com/yum/doc/yum-key.gpg<br /> &nbsp; &nbsp; &nbsp; &nbsp;https://packages.cloud.google.com/yum/doc/rpm-package-key.gpg<br />EOF<br /></code></pre>
<p>当然了，上面的<code>yum</code>源也是需要科学上网的，如果不能科学上网的话，我们可以使用阿里云的源进行安装：</p>
<pre class="prettyprint linenums"><code>cat &lt;&lt;EOF &gt; /etc/yum.repos.d/kubernetes.repo<br />[kubernetes]<br />name=Kubernetes<br />baseurl=http://mirrors.aliyun.com/kubernetes/yum/repos/kubernetes-el7-x86_64<br />enabled=1<br />gpgcheck=0<br />repo_gpgcheck=0<br />gpgkey=http://mirrors.aliyun.com/kubernetes/yum/doc/yum-key.gpg<br /> &nbsp; &nbsp; &nbsp; &nbsp;http://mirrors.aliyun.com/kubernetes/yum/doc/rpm-package-key.gpg<br />EOF<br /></code></pre>
<p>目前阿里云的源最新版本已经是1.10版本，所以可以直接安装。<code>yum</code>源配置完成后，执行安装命令即可：</p>
<pre class="prettyprint linenums"><code>$ yum makecache fast &amp;&amp; yum install -y kubelet kubeadm kubectl<br /></code></pre>
<p>正常情况我们可以都能顺利安装完成上面的文件。</p>
<h2>配置 kubelet</h2>
<p>安装完成后，我们还需要对<code>kubelet</code>进行配置，因为用<code>yum</code>源的方式安装的<code>kubelet</code>生成的配置文件将参数<code>--cgroup-driver</code>改成了<code>systemd</code>，而<code>docker</code>的<code>cgroup-driver</code>是<code>cgroupfs</code>，这二者必须一致才行，我们可以通过<code>docker info</code>命令查看：</p>
<pre class="prettyprint linenums"><code>$ docker info |grep Cgroup<br />Cgroup Driver: cgroupfs<br /></code></pre>
<p>修改文件<code>kubelet</code>的配置文件<code>/etc/systemd/system/kubelet.service.d/10-kubeadm.conf</code>，将其中的<code>KUBELET_CGROUP_ARGS</code>参数更改成<code>cgroupfs</code>：</p>
<pre class="prettyprint linenums"><code>Environment="KUBELET_CGROUP_ARGS=--cgroup-driver=cgroupfs"<br /></code></pre>
<p>另外还有一个问题是关于交换分区的，之前我们在手动搭建高可用的kubernetes 集群一文中已经提到过，<code>Kubernetes</code>从1.8开始要求关闭系统的 Swap ，如果不关闭，默认配置的<code>kubelet</code>将无法启动，我们可以通过 kubelet 的启动参数<code>--fail-swap-on=false</code>更改这个限制，所以我们需要在上面的配置文件中增加一项配置(在<code>ExecStart</code>之前)：</p>
<pre class="prettyprint linenums"><code>Environment="KUBELET_EXTRA_ARGS=--fail-swap-on=false"<br /></code></pre>
<p>当然最好的还是将<code>swap</code>给关掉，这样能提高<code>kubelet</code>的性能。修改完成后，重新加载我们的配置文件即可：</p>
<pre class="prettyprint linenums"><code>$ systemctl daemon-reload<br /></code></pre>
<h2>集群安装</h2>
<h3>初始化</h3>
<p>到这里我们的准备工作就完成了，接下来我们就可以在<code>master</code>节点上用<code>kubeadm</code>命令来初始化我们的集群了：</p>
<pre class="prettyprint linenums"><code>$ kubeadm init --kubernetes-version=v1.10.0 --pod-network-cidr=10.244.0.0/16 --apiserver-advertise-address=192.168.11.1<br /></code></pre>
<p>命令非常简单，就是<code>kubeadm init</code>，后面的参数是需要安装的集群版本，因为我们这里选择<code>flannel</code>作为 Pod 的网络插件，所以需要指定<code>&ndash;pod-network-cidr=10.244.0.0/16</code>，然后是<code>apiserver</code>的通信地址，这里就是我们<code>master</code>节点的IP 地址。执行上面的命令，如果出现<br /><code>running with swap on is not supported. Please disable swap</code>之类的错误，则我们还需要增加一个参数<code>&ndash;ignore-preflight-errors=Swap</code>来忽略<code>swap</code>的错误提示信息：</p>
<pre class="prettyprint linenums"><code>$ kubeadm init \<br /> &nbsp; --kubernetes-version=v1.10.0 \<br /> &nbsp; --pod-network-cidr=10.244.0.0/16 \<br /> &nbsp; --apiserver-advertise-address=192.168.11.1 \<br /> &nbsp; --ignore-preflight-errors=Swap<br />[init] Using Kubernetes version: v1.10.0<br />[init] Using Authorization modes: [Node RBAC]<br />[preflight] Running pre-flight checks.<br /> &nbsp; &nbsp;[WARNING FileExisting-crictl]: crictl not found in system path<br />Suggestion: go get github.com/kubernetes-incubator/cri-tools/cmd/crictl<br />[preflight] Starting the kubelet service<br />[certificates] Generated ca certificate and key.<br />[certificates] Generated apiserver certificate and key.<br />[certificates] apiserver serving cert is signed for DNS names [ydzs-master1 kubernetes kubernetes.default kubernetes.default.svc kubernetes.default.svc.cluster.local] and IPs [10.96.0.1 10.151.30.57]<br />[certificates] Generated apiserver-kubelet-client certificate and key.<br />[certificates] Generated etcd/ca certificate and key.<br />[certificates] Generated etcd/server certificate and key.<br />[certificates] etcd/server serving cert is signed for DNS names [localhost] and IPs [127.0.0.1]<br />[certificates] Generated etcd/peer certificate and key.<br />[certificates] etcd/peer serving cert is signed for DNS names [ydzs-master1] and IPs [10.151.30.57]<br />[certificates] Generated etcd/healthcheck-client certificate and key.<br />[certificates] Generated apiserver-etcd-client certificate and key.<br />[certificates] Generated sa key and public key.<br />[certificates] Generated front-proxy-ca certificate and key.<br />[certificates] Generated front-proxy-client certificate and key.<br />[certificates] Valid certificates and keys now exist in "/etc/kubernetes/pki"<br />[kubeconfig] Wrote KubeConfig file to disk: "/etc/kubernetes/admin.conf"<br />[kubeconfig] Wrote KubeConfig file to disk: "/etc/kubernetes/kubelet.conf"<br />[kubeconfig] Wrote KubeConfig file to disk: "/etc/kubernetes/controller-manager.conf"<br />[kubeconfig] Wrote KubeConfig file to disk: "/etc/kubernetes/scheduler.conf"<br />[controlplane] Wrote Static Pod manifest for component kube-apiserver to "/etc/kubernetes/manifests/kube-apiserver.yaml"<br />[controlplane] Wrote Static Pod manifest for component kube-controller-manager to "/etc/kubernetes/manifests/kube-controller-manager.yaml"<br />[controlplane] Wrote Static Pod manifest for component kube-scheduler to "/etc/kubernetes/manifests/kube-scheduler.yaml"<br />[etcd] Wrote Static Pod manifest for a local etcd instance to "/etc/kubernetes/manifests/etcd.yaml"<br />[init] Waiting for the kubelet to boot up the control plane as Static Pods from directory "/etc/kubernetes/manifests".<br />[init] This might take a minute or longer if the control plane images have to be pulled.<br />[apiclient] All control plane components are healthy after 22.007661 seconds<br />[uploadconfig] Storing the configuration used in ConfigMap "kubeadm-config" in the "kube-system" Namespace<br />[markmaster] Will mark node ydzs-master1 as master by adding a label and a taint<br />[markmaster] Master ydzs-master1 tainted and labelled with key/value: node-role.kubernetes.io/master=""<br />[bootstraptoken] Using token: 8xomlq.0cdf2pbvjs2gjho3<br />[bootstraptoken] Configured RBAC rules to allow Node Bootstrap tokens to post CSRs in order for nodes to get long term certificate credentials<br />[bootstraptoken] Configured RBAC rules to allow the csrapprover controller automatically approve CSRs from a Node Bootstrap Token<br />[bootstraptoken] Configured RBAC rules to allow certificate rotation for all node client certificates in the cluster<br />[bootstraptoken] Creating the "cluster-info" ConfigMap in the "kube-public" namespace<br />[addons] Applied essential addon: kube-dns<br />[addons] Applied essential addon: kube-proxy

Your Kubernetes master has initialized successfully!

To start using your cluster, you need to run the following as a regular user:

 &nbsp;mkdir -p $HOME/.kube<br /> &nbsp;sudo cp -i /etc/kubernetes/admin.conf $HOME/.kube/config<br /> &nbsp;sudo chown $(id -u):$(id -g) $HOME/.kube/config

You should now deploy a pod network to the cluster.<br />Run "kubectl apply -f [podnetwork].yaml" with one of the options listed at:<br /> &nbsp;https://kubernetes.io/docs/concepts/cluster-administration/addons/

You can now join any number of machines by running the following on each node<br />as root:

 &nbsp;kubeadm join 192.168.11.1:6443 --token 8xomlq.0cdf2pbvjs2gjho3 --discovery-token-ca-cert-hash sha256:92802317cb393682c1d1356c15e8b4ec8af2b8e5143ffd04d8be4eafb5fae368<br /></code></pre>
<p>上面的信息记录了<code>kubeadm</code>初始化整个集群的过程，生成相关的各种证书、<code>kubeconfig</code>文件、<code>bootstraptoken</code>等等，后边是使用<code>kubeadm join</code>往集群中添加节点时用到的命令，下面的命令是配置如何使用<code>kubectl</code>访问集群的方式：</p>
<pre class="prettyprint linenums"><code> &nbsp;mkdir -p $HOME/.kube<br /> &nbsp;sudo cp -i /etc/kubernetes/admin.conf $HOME/.kube/config<br /> &nbsp;sudo chown $(id -u):$(id -g) $HOME/.kube/config<br /></code></pre>
<p>最后给出了将节点加入集群的命令：</p>
<pre class="prettyprint linenums"><code>kubeadm join 192.168.11.1:6443 --token 8xomlq.0cdf2pbvjs2gjho3 --discovery-token-ca-cert-hash sha256:92802317cb393682c1d1356c15e8b4ec8af2b8e5143ffd04d8be4eafb5fae368<br /></code></pre>
<p>我们根据上面的提示配置好<code>kubectl</code>后，就可以使用<code>kubectl</code>来查看集群的信息了：</p>
<pre class="prettyprint linenums"><code>$ kubectl get cs<br />NAME &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; STATUS &nbsp; &nbsp;MESSAGE &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;ERROR<br />scheduler &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;Healthy &nbsp; ok<br />controller-manager &nbsp; Healthy &nbsp; ok<br />etcd-0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; Healthy &nbsp; {"health": "true"}<br />$ kubectl get csr<br />NAME &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; AGE &nbsp; &nbsp; &nbsp; REQUESTOR &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; CONDITION<br />node-csr-8qygb8Hjxj-byhbRHawropk81LHNPqZCTePeWoZs3-g &nbsp; 1h &nbsp; &nbsp; &nbsp; &nbsp;system:bootstrap:8xomlq &nbsp; Approved,Issued<br />$ kubectl get nodes<br />NAME &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; STATUS &nbsp; &nbsp;ROLES &nbsp; &nbsp; AGE &nbsp; &nbsp; &nbsp; VERSION<br />ydzs-master1 &nbsp; Ready &nbsp; &nbsp; master &nbsp; &nbsp;3h &nbsp; &nbsp; &nbsp; &nbsp;v1.10.0<br /></code></pre>
<p>如果你的集群安装过程中遇到了其他问题，我们可以使用下面的命令来进行重置：</p>
<pre class="prettyprint linenums"><code>$ kubeadm reset<br />$ ifconfig cni0 down &amp;&amp; ip link delete cni0<br />$ ifconfig flannel.1 down &amp;&amp; ip link delete flannel.1<br />$ rm -rf /var/lib/cni/<br /></code></pre>
<h3>安装 Pod Network</h3>
<p>接下来我们来安装<code>flannel</code>网络插件，很简单，和安装普通的<code>POD</code>没什么两样：</p>
<pre class="prettyprint linenums"><code>$ wget https://raw.githubusercontent.com/coreos/flannel/master/Documentation/kube-flannel.yml<br />$ kubectl apply -f &nbsp;kube-flannel.yml<br />clusterrole.rbac.authorization.k8s.io "flannel" created<br />clusterrolebinding.rbac.authorization.k8s.io "flannel" created<br />serviceaccount "flannel" created<br />configmap "kube-flannel-cfg" created<br />daemonset.extensions "kube-flannel-ds" created<br /></code></pre>
<p>另外需要注意的是如果你的节点有多个网卡的话，需要在<code>kube-flannel.yml</code>中使用<code>--iface</code>参数指定集群主机内网网卡的名称，否则可能会出现dns无法解析。<code>flanneld</code>启动参数加上<code>--iface=&lt;iface-name&gt;</code></p>
<pre class="prettyprint linenums"><code>args:<br />- --ip-masq<br />- --kube-subnet-mgr<br />- --iface=eth0<br /></code></pre>
<p>安装完成后使用<code>kubectl get pods</code>命令可以查看到我们集群中的组件运行状态，如果都是<code>Running</code>状态的话，那么恭喜你，你的<code>master</code>节点安装成功了。</p>
<pre class="prettyprint linenums"><code>$ kubectl get pods --all-namespaces<br />NAMESPACE &nbsp; &nbsp; NAME &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; READY &nbsp; &nbsp; STATUS &nbsp; &nbsp;RESTARTS &nbsp; AGE<br />kube-system &nbsp; etcd-ydzs-master1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;1/1 &nbsp; &nbsp; &nbsp; Running &nbsp; 0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;10m<br />kube-system &nbsp; kube-apiserver-ydzs-master1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;1/1 &nbsp; &nbsp; &nbsp; Running &nbsp; 0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;10m<br />kube-system &nbsp; kube-controller-manager-ydzs-master1 &nbsp; 1/1 &nbsp; &nbsp; &nbsp; Running &nbsp; 0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;10m<br />kube-system &nbsp; kube-dns-86f4d74b45-f5595 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;3/3 &nbsp; &nbsp; &nbsp; Running &nbsp; 0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;10m<br />kube-system &nbsp; kube-flannel-ds-qxjs2 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;1/1 &nbsp; &nbsp; &nbsp; Running &nbsp; 0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;1m<br />kube-system &nbsp; kube-proxy-vf5fg &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 1/1 &nbsp; &nbsp; &nbsp; Running &nbsp; 0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;10m<br />kube-system &nbsp; kube-scheduler-ydzs-master1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;1/1 &nbsp; &nbsp; &nbsp; Running &nbsp; 0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;10m<br /></code></pre>
<p><code>kubeadm</code>初始化完成后，默认情况下<code>Pod</code>是不会被调度到<code>master</code>节点上的，所以现在还不能直接测试普通的<code>Pod</code>，需要添加一个工作节点后才可以。</p>
<h3>添加节点</h3>
<p>同样的上面的环境配置、docker 安装、kubeadmin、kubelet、kubectl 这些都在Node(192.168.11.2)节点安装配置好过后，我们就可以直接在 Node 节点上执行<code>kubeadm join</code>命令了（上面初始化的时候有），同样加上参数<code>--ignore-preflight-errors=Swap</code>:</p>
<pre class="prettyprint linenums"><code>$ kubeadm join 192.168.11.1:6443 --token 8xomlq.0cdf2pbvjs2gjho3 --discovery-token-ca-cert-hash sha256:92802317cb393682c1d1356c15e8b4ec8af2b8e5143ffd04d8be4eafb5fae368 --ignore-preflight-errors=Swap<br />[preflight] Running pre-flight checks.<br /> &nbsp; &nbsp;[WARNING Swap]: running with swap on is not supported. Please disable swap<br /> &nbsp; &nbsp;[WARNING FileExisting-crictl]: crictl not found in system path<br />Suggestion: go get github.com/kubernetes-incubator/cri-tools/cmd/crictl<br />[discovery] Trying to connect to API Server "10.151.30.57:6443"<br />[discovery] Created cluster-info discovery client, requesting info from "https://192.168.11.1:6443"<br />[discovery] Requesting info from "https://10.151.30.57:6443" again to validate TLS against the pinned public key<br />[discovery] Cluster info signature and contents are valid and TLS certificate validates against pinned roots, will use API Server "10.151.30.57:6443"<br />[discovery] Successfully established connection with API Server "10.151.30.57:6443"

This node has joined the cluster:<br />* Certificate signing request was sent to master and a response<br /> &nbsp;was received.<br />* The Kubelet was informed of the new secure connection details.

Run 'kubectl get nodes' on the master to see this node join the cluster.<br /></code></pre>
<p>我们可以看到该节点已经加入到集群中去了，然后我们把<code>master</code>节点的<code>~/.kube/config</code>文件拷贝到当前节点对应的位置即可使用<code>kubectl</code>命令行工具了。</p>
<pre class="prettyprint linenums"><code>$ kubectl get nodes<br />NAME &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; STATUS &nbsp; &nbsp;ROLES &nbsp; &nbsp; AGE &nbsp; &nbsp; &nbsp; VERSION<br />evjfaxic &nbsp; &nbsp; &nbsp; Ready &nbsp; &nbsp; &lt;none&gt; &nbsp; &nbsp;1h &nbsp; &nbsp; &nbsp; &nbsp;v1.10.0<br />ydzs-master1 &nbsp; Ready &nbsp; &nbsp; master &nbsp; &nbsp;3h &nbsp; &nbsp; &nbsp; &nbsp;v1.10.0</code></pre>
<pre class="prettyprint linenums"><code><br />创建个nginx pod测试一下<br />docker pull </code>registry.cn-hangzhou.aliyuncs.com/qinyujia-test/nginx</pre>
<div>
<pre class="prettyprint linenums">apiVersion: v1<br />
kind: Pod<br />
metadata:<br />
  name: nginx<br />
  labels:<br />
     app: nginx<br />
spec:<br />
     containers:<br />
        - name: nginx<br />
          image: registry.cn-hangzhou.aliyuncs.com/qinyujia-test/nginx<br />
          imagePullPolicy: IfNotPresent<br />
          ports:<br />
          - containerPort: 80<br />
     restartPolicy: Always<br />
---<br />
apiVersion: v1<br />
kind: Service<br />
metadata:<br />
  name: nginx-service<br />
spec:<br />
  type: NodePort<br />
  sessionAffinity: ClientIP<br />
  selector:<br />
    app: nginx<br />
  ports:<br />
    - port: 80<br />
      nodePort: 30080</pre>
</div>
<p>kubectl create -f hello.yaml</p>
<pre class="prettyprint linenums"><code>

</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnv2eg8.html">RTSP协议转换RTMP直播协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8knpyj8.html">System&period;Linq&period;Dynamic的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxejoz8.html">&period;Net消息队列的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93v11r8.html">安装oracle数据库，登录 时无法连接目标机</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwm6yq.html">maven project 更新总是jre-1&period;5</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q70mkj8.html">iOS越狱开发（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd472zq.html">&lbrack;转&rsqb;centos 下 autoconf版本升级</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ompkpq.html">软件工程（c编码实践） 学习笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0o124q.html">Could not launch process failed&colon;security</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd7xyl8.html">VM 映像</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkw2yj8.html">裸机离奇事件：Freescale usb 有关fault</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1one9.html">poj 2689 Prime Distance&lpar;大区间素数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kljm29.html">poj 1008</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk4rr08.html">iptables 命令详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1o1gzq.html">数据与C</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkmddd8.html">江湖问题研究-- intent传递有没有大小限制，是多少？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jr1nl8.html">C&sol;C&plus;&plus; 函数指针使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oeklk8.html">Git中删除指定文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1ynvxq.html">rabbitmq 生产者 消费者（多个线程消费同一个队列里面的任务。）   一个通用rabbitmq消费确认，快速并发运行的框架。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m26yy2q.html">最基本的区块链hello world&lpar;python3实现&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnn0vygq.html">【LOJ】&num;2587&period; 「APIO2018」铁人两项</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pkpyg8.html">python之markdown转html</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql17oee9.html">linux查询系统负载</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kvxowq.html">react篇章-React State&lpar;状态&rpar;-组件都是真正隔离的</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlx5kl9.html">DNS 设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjloj0q.html">基于Apollo实现&period;NET Core微服务统一配置&lpar;测试环境-单机&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kv0mxq.html">sqlldr 远程数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/963g5wy9.html">iOS 11开发教程（七）编写第一个iOS11代码Hello&comma;World</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlxr0z9.html">&lbrack; 转载 &rsqb; Java基础4--Java中的static关键字解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko4v73q.html">JS AngualrJs 指令</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
